----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Counter2 is
    Port ( Clk,Reset : in   STD_LOGIC;
	        Sw :        in   STD_LOGIC_VECTOR (1 downto 0);
           Ld :        out  STD_LOGIC_VECTOR (7 downto 0));
end Counter2;

architecture Behavioral of Counter2 is
   signal Q: STD_LOGIC_VECTOR (31 downto 0) := (others => '0');
begin

   with Sw select
	Ld <= Q(  7 downto  0) when "00",
	      Q( 15 downto  8) when "01",
	      Q( 23 downto 16) when "10",
	      Q( 31 downto 24) when others;
						
   process( Clk)
	begin
		if Rising_edge( Clk) then
			if Reset='1' then
				Q <= (others=>'0');
			else
				Q <= Q+1;
			end if;
		end if;
	end process;

end Behavioral;

