----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity Counter5 is
    Port ( Clk,RESET,UP,DOWN,LOAD : in  STD_LOGIC;
           Ld : out  STD_LOGIC_VECTOR (7 downto 0);
           Sw : in  STD_LOGIC_VECTOR (7 downto 0));
end Counter5;

architecture Behavioral of Counter5 is
   signal Xreset, Xup, Xdown, Xload: STD_LOGIC_VECTOR (1 downto 0) := "00";
	signal Q:                         STD_LOGIC_VECTOR (7 downto 0);
begin

   Ld <= Q;		
   
	process( Clk)   
	begin
	   if Rising_edge( Clk) then
		   Xreset <= RESET & Xreset(1);
		   Xup    <= UP    & Xup(1);
		   Xdown  <= DOWN  & Xdown(1);
		   Xload  <= LOAD  & Xload(1);
			
			if Xreset="10" then
			   Q <= "00000000";
			elsif Xload="10" then
			   Q <= Sw;
			elsif Xup="10" then
				Q <= Q+1;
			elsif Xdown="10" then
			   Q <= Q-1;
			end if;
		end if;
	end process;
		
end Behavioral;

